package com.isartdigital.game.sprites;

import com.isartdigital.utils.game.factory.MovieClipAnimFactory;
import com.isartdigital.utils.game.StateGraphic;
import com.isartdigital.utils.system.DeviceCapabilities;
import pixi.core.text.Text;
import pixi.extras.MovieClip;

	
/**
 * ...
 * @author Cindy Asselin de Beauville
 */
class Score extends StateGraphic 
{
	
	/**
	 * instance unique de la classe Score
	 */
	private static var instance: Score;
	
	public var actualScore:Int = 0;
	public var txt:Text;
	private var txtStyle:TextStyle = { fill:'white', stroke: 'black', strokeThickness: 5, font : "62px tao" };
	
	/**
	 * Retourne l'instance unique de la classe, et la crée si elle n'existait pas au préalable
	 * @return instance unique
	 */
	public static function getInstance (): Score {
		if (instance == null) instance = new Score();
		return instance;
	}
	
	/**
	 * constructeur privé pour éviter qu'une instance soit créée directement
	 */
	private function new() 
	{
		super();
		factory = new MovieClipAnimFactory();
		assetName = "Score";
		init();
	}
	
	public function init() {
		start();
		setScore();
		setModeNormal();
	}
	
	override function doActionNormal():Void 
	{
		super.doActionNormal();
		txt.text = cast(actualScore);
	}
	
	override private function setModeNormal():Void {
		setState(DEFAULT_STATE, true);
		cast(anim, MovieClip).anchor.set(0.5, 0.5);
		position.set(InputZone.getInstance().x - anim.width, anim.height/2);
		super.setModeNormal();
	}
	
	private function setScore():Void {
		txt = new Text(cast(actualScore), txtStyle);
		txt.anchor.set(0.5, 0.5);
		addChild(txt);
	}
	
	
	/**
	 * détruit l'instance unique et met sa référence interne à null
	 */
	override public function destroy (): Void {
		super.destroy();
		instance = null;
	}

}